% Eagle airline example
k=9;
numberseats=5;
money=52.5e3; returnrate=.08;

param_names={'charter ratio','capacity','price level',...
             'hours flown','operating costs per hour',...
			 'percentage financed','interest rate',...
			 'insurance','purchase price'};
lowvals =[.45,.4, 95, 500,230,.3,.105,18e3,85e3];
basevals=[ .5,.5,100, 800,245,.4,.115,20e3,87.5e3];
highvals=[ .7,.6,108,1000,260,.5,.13, 25e3,90e3];
trafo=@(u)[triinv(u(:,1),lowvals(1),basevals(1),highvals(1)),...
	       triinv(u(:,2),lowvals(2),basevals(2),highvals(2)),...
		   triinv(u(:,3),lowvals(3),basevals(3),highvals(3)),...
		   triinv(u(:,4),lowvals(4),basevals(4),highvals(4)),...
		   triinv(u(:,5),lowvals(5),basevals(5),highvals(5)),...
		   triinv(u(:,6),lowvals(6),basevals(6),highvals(6)),...
		   triinv(u(:,7),lowvals(7),basevals(7),highvals(7)),...
		   triinv(u(:,8),lowvals(8),basevals(8),highvals(8)),...
		   triinv(u(:,9),lowvals(9),basevals(9),highvals(9))];	   
revenue=@(x)(x(:,1)*3.25+(1-x(:,1)).*x(:,2).* ...
         numberseats).*x(:,3).*x(:,4);   
costs=@(x)x(:,4).*x(:,5)+x(:,8)+x(:,9).*x(:,6).*x(:,7);
profit=@(x)revenue(x)-costs(x);
model=@(x)profit(x)-money*returnrate;

% gradient
Drevenue=@(x)[(3.25-x(:,2).*numberseats).*x(:,3).*x(:,4),...
    (1-x(:,1)).*numberseats.*x(:,3).*x(:,4),...
    (x(:,1)*3.25+(1-x(:,1)).*x(:,2).* numberseats).*x(:,4),...
    (x(:,1)*3.25+(1-x(:,1)).*x(:,2).* numberseats).*x(:,3),...
    zeros(size(x,1),5)];
Dcosts=@(x)[zeros(size(x,1),3),x(:,5),x(:,4),x(:,9).*x(:,7),...
    x(:,9).*x(:,6),ones(size(x,1),1),x(:,6).*x(:,7)];
Dmodel=@(x)Drevenue(x)-Dcosts(x);
%% for tornado plot
Id=eye(k);
breakeven=@(c)basevals(c)+fzero(@(x)model(basevals+Id(c,:)*x),0);
%% correlation
C=Id;
C(3,4)=-.5;C(4,3)=-.5;
C(2,4)=.5;C(4,2)=.5;
C(3,2)=-.25;C(2,3)=-.25;
C(1,[4,3,2])=[.25 .25 -.25];C([4,3,2],1)=[.25 .25 -.25];
C(5,[2,1])=[.25 .25];C([2,1],5)=[.25 .25];
C(8,4)=.25;C(4,8)=.25;
C(6,[5 8])=[.25,.25];C([5 8],6)=[.25,.25];
C(7,6)=-.5;C(6,7)=-.5;
C(9,[6,7])=[.75,-.25];C([6,7],9)=[.75,-.25];
ii=[4,3,2,1,5,8,6,7,9]; % 
% u=sobolpoints(n,k);v=iccorrelate(u,C,'UseQRP',0)

% Wang and Dyer 2012 
if 0
    %%
   at={{@(u)81.94*(133.96-81.94)*betainv(u,9,15),{},'P','price level'},...
       {@(u)66.91+(1135.26-66.91)*betainv(u,4,2),{},'H','hours flown'},...
       {'beta',{20,20},'C','capacity'},...
       {'norm',{245,11.72},'O','operating costs'}};
   
   Sigma_X=eye(4,4)+diag([-.5,.5,.25],-1)+diag([-.5,.5,.25],1)+...
   diag([-.25,0],-2)+diag([-.25,0],2);
   Sigma_Z=2*sin(pi*Sigma_X/6);
   % norta
   trafo=@(u)autotrans(normcdf(norminv(u)*chol(Sigma_Z)),at);
   WDmodel=@(x)profit([basevals(1)*ones(length(x),1),x(:,3),x(:,1),...
       x(:,2),x(:,4),ones(length(x),1)*basevals(6:k)]);
   
   n=1024;
   x=trafo(sobolpoints(n,length(at)));y=WDmodel(x);
   %% alternatively
   %% Sigma_Z(1:5:4^2)=1;xx=iccorrelate(autotrans(u,at),Sigma_Z);
end
%% 
%n=1024;
n=4096;
at={{'tri',{lowvals(1),basevals(1),highvals(1)},'charter ratio'},...
    {'beta',{20,20},'capacity'},...
    {@(u)81.94*(133.96-81.94)*betainv(u,9,15),{},'price level'},...
    {@(u)66.91+(1135.26-66.91)*betainv(u,4,2),{},'hours flown'},...
    {'norm',{245,11.72},'operating costs'},...
    {'tri',{lowvals(6),basevals(6),highvals(6)},'percentage financed'},...
    {'tri',{lowvals(7),basevals(7),highvals(7)},'interest rate'},...
    {'tri',{lowvals(8),basevals(8),highvals(8)},'insurance'},...
    {'tri',{lowvals(9),basevals(9),highvals(9)},'purchase price'}};
    
D=2*sin(pi*C/6);D(1:(k+1):k^2)=1;
x=iccorrelate(trafo(sobolpoints(n,length(at))),D,'UseQRP',1);y=model(x);
for i=1:k;lbls{i}=at{i}{3};end
mn=min(x);mx=max(x);
%clf,partialdep(x,model,'ShowScatter',true,'ScatterData',y,...
%    'GfxTitle','Eagle Airlines','Labels',{lbls},...
%    'OutputLabel','decision theshold 0','ShowOneWay',30);
clf,partialdep(x,model,'SpiderPlot',true,...
    'GfxTitle','Eagle Airlines','Labels',{lbls},...
    'OutputLabel','decision theshold 0');

%% gradient
Dy=Dmodel(x);
clf,for i=1:k,subplot(3,3,i);plot(x(:,i),Dy(:,i),'.');
xlabel(['x_{' num2str(i) '} (' lbls{i} ')']);
ylabel(['$\partial_{' num2str(i) '}y$'],'interpreter','latex');
end
 